import * as ReactManagedDraggable from 'react-managed-draggable';
import * as StateModel from './state-model';
export interface DropArea {
    top: number;
    left: number;
    width: number;
    height: number;
}
export interface DropResolutionTab<T> {
    type: 'tab';
    dropArea: DropArea;
    stack: StateModel.Stack<T>;
    index: number;
}
export interface DropResolutionContainer<T> {
    type: 'container';
    dropArea: DropArea;
    stack: StateModel.Stack<T>;
}
export interface DropResolutionRoot {
    type: 'root';
    dropArea: DropArea;
}
export declare type DropResolution<T> = DropResolutionTab<T> | DropResolutionContainer<T>;
export declare const computeDropArea: (element: Element) => DropArea;
export declare const dropAreasEqual: (dropAreaA: DropArea, dropAreaB: DropArea) => boolean;
export declare const pointInDropArea: (dropArea: DropArea, point: ReactManagedDraggable.XY) => boolean;
