import * as React from 'react';
import * as ReactManagedDragable from 'react-managed-draggable';
import * as DropModel from './drop-model';
import { FloatingStartOptions, FloatyManager } from './floaty-manager';
import * as RenderersModel from './renderers-model';
import * as StateModel from './state-model';
interface Props<T> {
    state: StateModel.State<T>;
    onStateChange: (state: StateModel.State<T>) => void;
    renderers: RenderersModel.FloatyRenderers<T>;
}
interface State<T> {
    currentMousePosition: ReactManagedDragable.XY | null;
    dropResolutions: DropModel.DropResolution<T>[];
    rootDropArea: DropModel.DropArea | null;
}
export declare class Floaty<T> extends React.PureComponent<Props<T>, State<T>> implements FloatyManager<T> {
    state: State<T>;
    private portal;
    private dropResolutions;
    private eventTarget;
    private raf;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private renderLayout;
    private renderDropResolution;
    private renderFloating;
    private getCandidateDropResolution;
    private registerFloatHandlers;
    private unregisterFloatHandlers;
    private updateDropAreas;
    private updateState;
    private onLayoutChange;
    private onRowOrColumnUpdateFractions;
    registerDropResolutions: (key: unknown, dropResolutions: DropModel.DropResolution<T>[]) => void;
    unregisterDropResolutions: (key: unknown) => void;
    private updateDropResolutions;
    updateColumnFractions: (rowOrColumn: StateModel.Column<T> | StateModel.Row<T>, index1: number, fraction1: number, index2: number, fraction2: number) => void;
    updateRowFractions: (rowOrColumn: StateModel.Column<T> | StateModel.Row<T>, index1: number, fraction1: number, index2: number, fraction2: number) => void;
    activateStackItem: (stackItem: StateModel.StackItem<T>) => void;
    closeTab: (stackItem: StateModel.StackItem<T>) => void;
    replaceItem: (stackItem: StateModel.StackItem<T>, item: T) => void;
    private handleMove;
    private handleUp;
    startFloat: (stackItem: StateModel.StackItem<T>, options: FloatingStartOptions) => void;
    getLayout: () => StateModel.Column<T> | StateModel.Row<T> | StateModel.Stack<T> | null;
    findStack: (stackItem: StateModel.StackItem<T>) => StateModel.Stack<T> | null;
    private replaceInPath;
    private findPath;
}
export {};
