import * as ReactManagedDragable from 'react-managed-draggable';
import * as DropModel from './drop-model';
import * as StateModel from './state-model';
declare type TraverseOrder = 'pre-order' | 'post-order';
export declare class StaticUtilities {
    static traverseLayoutTree<T>(layout: StateModel.Layout<T>, callback: (node: StateModel.Layout<T>) => void, order: TraverseOrder): void;
    static minimizeLayout<T>(layout: StateModel.Layout<T> | null): StateModel.Layout<T> | null;
    static findStackItem<T>(predicate: (item: T) => boolean, layout: StateModel.Layout<T>): StateModel.StackItem<T> | null;
    static findStack<T>(stackItem: StateModel.StackItem<T>, from: StateModel.Layout<T> | null): StateModel.Stack<T> | null;
    static getContentResolutionSide(resolution: DropModel.DropResolutionContainer<unknown>, mousePosition: ReactManagedDragable.XY): 'left' | 'right' | 'top' | 'bottom';
}
export {};
